<!DOCTYPE html><html lang="en" data-reactroot=""><head><title>Creating Your App&#x27;s Interface with SwiftUI | Apple Developer Documentation</title><meta content="width=device-width, initial-scale=1 viewport-fit=cover" name="viewport"/><meta data-pid="492525"/><link href="https://www.apple.com/wss/fonts?families=SF+Pro,v1|SF+Mono,v1|SF+Pro+Icons,v1" media="all" rel="stylesheet" type="text/css"/><link href="/documentation/__assets/application-e5bb1544.css" media="all" rel="stylesheet" type="text/css"/><noscript><link href="/documentation/__assets/nojs-c6be9131.css" media="all" rel="stylesheet" type="text/css"/></noscript><link rel="mask-icon" href="/documentation/__assets/apple-logo.svg" color="#000"/><link rel="shortcut icon" href="/documentation/__assets/favicon.ico"/><script src="/documentation/__assets/shared-b7676010.js"></script><script id="init-data" type="application/json">{"variant":{"paths":["documentation\/xcode\/creating_your_app_s_interface_with_swiftui"]}}</script><script src="/documentation/__assets/init-6128d031.js"></script></head><body><div id="_omniture_top">
      <script>
        var s_account="awdappledeveloper"
      </script>
      <script src="https://developer.apple.com/assets/metrics/scripts/analytics.js"></script>
      <script>
        s.pageName= AC && AC.Tracking && AC.Tracking.pageName();
        s.channel="www.documentation.developer"

        var s_code=s.t();if(s_code)document.write(s_code)
      </script>
    </div><div id="app"><div><a href="#main" id="skip-localnav" class="showonfocus hidden">Skip Navigation</a><aside id="ac-gn-segmentbar" class="ac-gn-segmentbar" lang="en-US" dir="ltr"></aside><input type="checkbox" id="ac-gn-menustate" class="ac-gn-menustate"/><nav id="ac-globalnav" class="no-js" role="navigation" aria-label="Global" data-hires="false" data-analytics-region="global nav" lang="en-US" dir="ltr" data-store-locale="us" data-store-api="/[storefront]/shop/bag/status" data-search-locale="en_US" data-search-api="/search-services/suggestions/">
      <div class="ac-gn-content">
        <ul class="ac-gn-header">
          <li class="ac-gn-item ac-gn-menuicon">
            <label class="ac-gn-menuicon-label" for="ac-gn-menustate" aria-hidden="true">
              <span class="ac-gn-menuicon-bread ac-gn-menuicon-bread-top">
                <span class="ac-gn-menuicon-bread-crust ac-gn-menuicon-bread-crust-top"></span>
              </span>
              <span class="ac-gn-menuicon-bread ac-gn-menuicon-bread-bottom">
                <span class="ac-gn-menuicon-bread-crust ac-gn-menuicon-bread-crust-bottom"></span>
              </span>
            </label>
            <a href="#ac-gn-menustate" role="button" class="ac-gn-menuanchor ac-gn-menuanchor-open" id="ac-gn-menuanchor-open">
              <span class="ac-gn-menuanchor-label">Global Nav Open Menu</span>
            </a>
            <a href="#" role="button" class="ac-gn-menuanchor ac-gn-menuanchor-close" id="ac-gn-menuanchor-close">
              <span class="ac-gn-menuanchor-label">Global Nav Close Menu</span>
            </a>
          </li>
          <li class="ac-gn-item ac-gn-apple">
            <a class="ac-gn-link ac-gn-link-apple-developer" href="/" data-analytics-title="appledeveloper home" id="ac-gn-firstfocus-small">
              <span class="ac-gn-link-text">Apple Developer</span>
            </a>
          </li>
        </ul>
        <div class="ac-gn-search-placeholder-container" role="search">
          <div class="ac-gn-search ac-gn-search-small">
            <a id="ac-gn-link-search-small" class="ac-gn-link" href="/search/" data-analytics-title="search" data-analytics-click="search" data-analytics-intrapage-link aria-label="Search Developer">
              <div class="ac-gn-search-placeholder-bar">
                <div class="ac-gn-search-placeholder-input">
                  <div class="ac-gn-search-placeholder-input-text" aria-hidden="true">
                    <div class="ac-gn-link-search ac-gn-search-placeholder-input-icon"></div>
                    <span class="ac-gn-search-placeholder">Search Developer</span>
                  </div>
                </div>
                <div class="ac-gn-searchview-close ac-gn-searchview-close-small ac-gn-search-placeholder-searchview-close">
                  <span class="ac-gn-searchview-close-cancel" aria-hidden="true">Cancel</span>
                </div>
              </div>
            </a>
          </div>
        </div>
        <ul class="ac-gn-list">
          <li class="ac-gn-item ac-gn-apple">
            <a class="ac-gn-link ac-gn-link-apple-developer" href="/" data-analytics-title="appledeveloper home" id="ac-gn-firstfocus">
              <span class="ac-gn-link-text">Apple Developer</span>
              </a>
          </li>
          <li class="ac-gn-item ac-gn-item-menu ac-gn-discover">
            <a class="ac-gn-link ac-gn-link-discover" href="/discover/" data-analytics-title="discover">
              <span class="ac-gn-link-text">Discover</span>
              </a>
          </li>
          <li class="ac-gn-item ac-gn-item-menu ac-gn-design">
            <a class="ac-gn-link ac-gn-link-design" href="/design/" data-analytics-title="design">
              <span class="ac-gn-link-text">Design</span>
              </a>
          </li>
          <li class="ac-gn-item ac-gn-item-menu ac-gn-develop">
            <a class="ac-gn-link ac-gn-link-develop" href="/develop/" data-analytics-title="develop">
              <span class="ac-gn-link-text">Develop</span>
              </a>
          </li>
          <li class="ac-gn-item ac-gn-item-menu ac-gn-distribute">
            <a class="ac-gn-link ac-gn-link-distribute" href="/distribute/" data-analytics-title="distribute">
              <span class="ac-gn-link-text">Distribute</span>
              </a>
          </li>
          <li class="ac-gn-item ac-gn-item-menu ac-gn-dsupport">
            <a class="ac-gn-link ac-gn-link-dsupport" href="/support/" data-analytics-title="dsupport">
              <span class="ac-gn-link-text">Support</span>
              </a>
          </li>
          <li class="ac-gn-item ac-gn-item-menu ac-gn-account">
            <a class="ac-gn-link ac-gn-link-account" href="/account/" data-analytics-title="account">
              <span class="ac-gn-link-text">Account</span>
              </a>
          </li>
          <li class="ac-gn-item ac-gn-item-menu ac-gn-search" role="search">
            <a id="ac-gn-link-search" class="ac-gn-link ac-gn-link-search" href="/search/" data-analytics-title="search" data-analytics-click="search" data-analytics-intrapage-link aria-label="Search Developer"></a>
          </li>
        </ul>
        <aside id="ac-gn-searchview" class="ac-gn-searchview" role="search" data-analytics-region="search">
          <div class="ac-gn-searchview-content">
            <div class="ac-gn-searchview-bar">
              <div class="ac-gn-searchview-bar-wrapper">
                <form id="ac-gn-searchform" class="ac-gn-searchform" action="/search/" method="get">
                  <div class="ac-gn-searchform-wrapper">
                    <input id="ac-gn-searchform-input" class="ac-gn-searchform-input" type="text" name="q" aria-label="Search Developer" placeholder="Search Developer" autocorrect="off" autocapitalize="off" autocomplete="off" spellcheck="false" role="combobox" aria-autocomplete="list" aria-expanded="true" aria-owns="quicklinks suggestions" />
                    <button id="ac-gn-searchform-submit" class="ac-gn-searchform-submit" type="submit" disabled aria-label="Submit Search"></button>
                    <button id="ac-gn-searchform-reset" class="ac-gn-searchform-reset" type="reset" disabled aria-label="Clear Search">
                        <span class="ac-gn-searchform-reset-background"></span>
                      </button>
                  </div>
                </form>
                <button id="ac-gn-searchview-close-small" class="ac-gn-searchview-close ac-gn-searchview-close-small" aria-label="Cancel Search">
                    <span class="ac-gn-searchview-close-cancel" aria-hidden="true">
                      Cancel
                    </span>
                  </button>
              </div>
            </div>
            <aside id="ac-gn-searchresults" class="ac-gn-searchresults" data-string-quicklinks="Quick Links" data-string-suggestions="Suggested Searches" data-string-noresults=""></aside>
          </div>
          <button id="ac-gn-searchview-close" class="ac-gn-searchview-close" aria-label="Cancel Search">
              <span class="ac-gn-searchview-close-wrapper">
                <span class="ac-gn-searchview-close-left"></span>
                <span class="ac-gn-searchview-close-right"></span>
              </span>
            </button>
        </aside>
          </div>
    </nav><div class="ac-gn-blur"></div><div id="ac-gn-curtain" class="ac-gn-curtain"></div><div id="ac-gn-placeholder" class="ac-nav-placeholder"></div><input type="checkbox" id="localnav-menustate" class="localnav-menustate" aria-hidden="true"/><nav id="localnav" class="localnav localnav-dark theme-dark localnav-scrim localnav-noborder" role="navigation" aria-label="API Reference" data-sticky="true"><div class="localnav-wrapper"><div class="referencenav"><div class="localnav-background"></div><div class="localnav-content"><a href="/documentation" class="localnav-title">Documentation</a><div class="localnav-menu"><a href="#localnav-menustate" id="localnav-menustate-open" class="localnav-menucta-anchor localnav-menucta-anchor-open"><span class="localnav-menucta-anchor-label" aria-hidden="true">Open Menu</span></a><a href="#" id="localnav-menustate-close" class="localnav-menucta-anchor localnav-menucta-anchor-close"><span class="localnav-menucta-anchor-label" aria-hidden="true">Close Menu</span></a><div class="localnav-menu-tray"><ul aria-label="Breadcrumbs" class="localnav-menu-items localnav-menu-breadcrumbs"><li class="localnav-menu-item localnav-menu-breadcrumb-item"><a class="localnav-menu-link" href="/documentation/xcode">Xcode</a></li><li class="localnav-menu-item localnav-menu-breadcrumb-item"><div class="localnav-menu-breadcrumb-current-container localnav-menu-link current"><span aria-current="page" class="localnav-menu-breadcrumb-current">Creating Your App&#x27;s Interface with SwiftUI</span></div></li></ul><ul class="localnav-menu-items localnav-menu-settings" data-breadcrumbs-count="2"><li class="localnav-menu-setting language-container"><div class="language-toggle-container"><label for="language-toggle" class="language-toggle-label">Language:</label><select id="language-toggle" class="language-dropdown localnav-menu-link" style="width:auto"><option selected="" value="swift">Swift</option><option value="occ">Objective-C</option></select></div><div class="language-list-container"><span class="localnav-menu-setting-label">Language:</span><ul class="language-list"><li class="language-list-item"><span data-language="swift" aria-current="page" class="current-language">Swift</span></li><li class="language-list-item"><a href="/documentation/xcode/creating_your_app_s_interface_with_swiftui?language=objc" class="localnav-menu-setting-link">Objective-C</a></li></ul></div></li><li class="localnav-menu-setting"><span class="localnav-menu-setting-label">API Changes:</span><span class="changes-toggle">None</span></li></ul></div><div class="localnav-actions"><div class="localnav-action localnav-action-menucta" aria-hidden="true"><label for="localnav-menustate" class="localnav-menucta"><span class="localnav-menucta-chevron"></span></label></div></div></div></div></div></div></nav><label for="localnav-menustate" id="localnav-curtain" aria-hidden="true"></label><main role="main" id="main" class="main" tabindex="0"><div class="topic-title"><span class="eyebrow">Article</span><h1 class="topic-heading"><span>Creating Your App&#x27;s Interface with Swift<wbr/>UI</span></h1></div><div class="topic-container section-content row"><div class="topic-description column large-9 medium-9 small-12"><div class="topic-abstract abstract formatted-content"><div><p>Develop apps in SwiftUI with an interactive preview that keeps the code and layout in sync.</p></div></div></div><div class="topic-summary column large-3 medium-3 small-12"><div class="topic-summary-section onthispage"><nav class="onthispage-nav" aria-labelledby="onthispage-title"><p id="onthispage-title" class="topic-summary-section-label subsection-label">On This Page</p><ul class="topic-summary-section-list"><li class="topic-summary-section-item"><a href="#overview" class="icon icon-after icon-chevrondowncircle">Overview</a></li><li class="topic-summary-section-item"><a href="#see-also" class="icon icon-after icon-chevrondowncircle">See Also</a></li></ul></nav></div></div><div class="topic-content column large-9 medium-9 small-12" id="topic-content"><section id="overview" class="section"><h2>Overview</h2><div class="formatted-content"><div><p>If you choose the SwiftUI framework to develop your app, you can see an interactive preview as you lay out your user interface. Xcode keeps the changes you make to the source code, the user interface layout, and the inspector in sync. For example, when you edit attributes in the inspector, Xcode adds the corresponding code to the source file.</p></div><h3 id="3362152">Display the SwiftUI Preview</h3><div><p>To show the preview, select a file that uses SwiftUI in the project navigator, and choose Editor &gt; Canvas. Then click the Resume button in the upper-right corner of the canvas to start the preview. Xcode builds and runs the code, displaying the results directly in the canvas.</p><figure id="3381037"><img class="centered-block" src="https://docs-assets.developer.apple.com/published/8146913601/7a6b441e-d9b0-400a-b3f0-027413778674.png" srcSet="https://docs-assets.developer.apple.com/published/8146913601/7a6b441e-d9b0-400a-b3f0-027413778674.png 2x" alt="Screenshot showing a SwiftUI file selected in the project navigator and preview displayed in the editor area." width="720" height="auto"/></figure><p>Use the controls at the bottom of the preview to run the app on a simulated device in the canvas, with or without a debug session, or run the app on a connected device.</p></div><h3 id="3362154">Add Views and Modifiers</h3><div><p>To add views and modifiers to your app, click the Library button (+) in the toolbar to open the library, then drag user interface elements from the library to either the canvas or source code. Regardless of where you drop the elements, Xcode keeps the source code and the layout in sync.</p><figure id="3362210"><img class="centered-block" src="https://docs-assets.developer.apple.com/published/e74cff0c09/a07fe257-ab33-42ea-b1ae-4c9a909984aa.png" srcSet="https://docs-assets.developer.apple.com/published/e74cff0c09/a07fe257-ab33-42ea-b1ae-4c9a909984aa.png 2x" alt="Screenshot showing the library when a SwiftUI element is selected." width="142" height="auto"/></figure><p></p></div><h3 id="3362155">Edit User Interface Elements</h3><div><p>Edit element attributes using either the Action menu or the inspector, or by entering code in the source editor. Command-click the element in the canvas or the structure in the code, choose Show SwiftUI Inspector from the Action menu, then change the attributes in the next pane. Alternatively, choose View &gt; Inspectors &gt; Show Attributes Inspector, and change the attributes in the Attributes inspector that appears on the right.</p><figure id="3384914"><img class="centered-block" src="https://docs-assets.developer.apple.com/published/7a60b72cde/57c6dfb5-f977-43d2-abeb-01efcfd655b7.png" srcSet="https://docs-assets.developer.apple.com/published/7a60b72cde/57c6dfb5-f977-43d2-abeb-01efcfd655b7.png 2x" alt="Screenshot showing the Action menu in the canvas with the Show Attributes Inspector menu item selected." width="612" height="auto"/></figure><p></p></div><h3 id="3362156">Embed User Interface Elements</h3><div><p>Additionally, you can modify the user interface by embedding elements in other structures. Command-click an element in the source code or in the canvas, then choose an &quot;Embed in [Generic Structure]&quot; action from the pop-up menu. For example, choose &quot;Embed in HStack&quot; to embed an element that arranges a view&#x27;s children in a horizontal line.</p><figure id="3384913"><img class="centered-block" src="https://docs-assets.developer.apple.com/published/4f4304fa18/d659a2a4-b500-4e99-a005-f0ff62887239.png" srcSet="https://docs-assets.developer.apple.com/published/4f4304fa18/d659a2a4-b500-4e99-a005-f0ff62887239.png 2x" alt="Screenshot showing the Action menu in the source editor with the Embed in HStack menu item selected." width="612" height="auto"/></figure><p>To learn more about SwiftUI, go to <a href="/tutorials/swiftui/tutorials">Learn to Make Apps with SwiftUI</a>.</p></div></div></section></div></div><section id="see-also" class="contenttable section alt-light-container row"><div class="alt-light"><div class="section-content"><h2 class="contenttable-title">See Also</h2><section id="3193088" class="contenttable-section"><div class="contenttable-container row"><div class="contenttable-section-title-container column large-3 medium-3 small-12"><h3 class="contenttable-section-title">Interface</h3></div><div class="contenttable-section-content column large-9 medium-9 small-12"><div class="task-topics"><div class="task-topic"><div class="task-topic-info"><a class="has-adjacent-element symbol-name" href="/documentation/xcode/supporting_dark_mode_in_your_interface"><svg xmlns="http://www.w3.org/2000/svg" height="15" viewBox="0 0 22 30" class="svg-icon symbol-name-icon" aria-hidden="true"><title>Article</title><g id="Article" class="svg-icon-small"><path d="M12.87,0H0V2H0V28H0v2H22V9.13ZM20,28H2V2h9V12h9Zm0-18H13V3l7,7Z"></path></g></svg><span>Supporting Dark Mode in Your Interface</span></a><div class="task-topic-abstract task-topic-data abstract formatted-content"><div><p>Update colors, images, and behaviors so that your app adapts automatically when Dark Mode is active.</p></div></div></div></div><div class="task-topic"><div class="task-topic-info"><a class="has-adjacent-element symbol-name" href="/documentation/xcode/creating_custom_symbol_images_for_your_app"><svg xmlns="http://www.w3.org/2000/svg" height="15" viewBox="0 0 22 30" class="svg-icon symbol-name-icon" aria-hidden="true"><title>Article</title><g id="Article" class="svg-icon-small"><path d="M12.87,0H0V2H0V28H0v2H22V9.13ZM20,28H2V2h9V12h9Zm0-18H13V3l7,7Z"></path></g></svg><span>Creating Custom Symbol Images for Your App</span></a><div class="task-topic-abstract task-topic-data abstract formatted-content"><div><p>Create symbol images and expand on the icons provided by SF Symbols.</p></div></div></div></div></div></div></div></section></div></div></section></main><section id="globalfooter-wrapper"><footer id="globalfooter" role="contentinfo">
        <nav class="footer-breadory">
          <a href="/" class="home breadcrumbs-home"><span aria-hidden="true"></span><span class="breadcrumbs-home-label">Developer</span></a>
          <section class="breadcrumbs">
            <ol class="breadcrumbs-list">
              <li><a href=/documentation>Documentation</a></li>
            </ol>
          </section>
          <div id="directorynav" class="directorynav">
            <div id="dn-cola" class="column">
              <h3><a href="/discover/">Discover</a></h3>
              <ul>
                <li><a href="/macos/">macOS</a></li>
                <li><a href="/ios/">iOS</a></li>
                <li><a href="/watchos/">watchOS</a></li>
                <li><a href="/tvos/">tvOS</a></li>
                <li><a href="/safari/">Safari and Web</a></li>
                <li><a href="/games/">Games</a></li>
                <li><a href="/business/">Business</a></li>
                <li><a href="/education/">Education</a></li>
                <li><a href="/wwdc/">WWDC</a></li>
              </ul>
            </div>
            <div id="dn-colb" class="column">
              <h3><a href="/design/">Design</a></h3>
              <ul>
                <li><a href="/design/human-interface-guidelines/">Human Interface Guidelines</a></li>
                <li><a href="/design/resources/">Resources</a></li>
                <li><a href="/videos/design/">Videos</a></li>
                <li><a href="/design/awards/">Apple Design Awards</a></li>
                <li><a href="/accessibility/">Accessibility</a></li>
                <li><a href="/internationalization/">Internationalization</a></li>
                <li><a href="/accessories/">Accessories</a></li>
              </ul>
            </div>
            <div id="dn-colc" class="column">
              <h3><a href="/develop/">Develop</a></h3>
              <ul>
                <li><a href="/xcode/">Xcode</a></li>
                <li><a href="/swift/">Swift</a></li>
                <li><a href="/swift-playgrounds/">Swift Playgrounds</a></li>
                <li><a href="/testflight/">TestFlight</a></li>
                <li><a href="/documentation/">Documentation</a></li>
                <li><a href="/videos/">Videos</a></li>
                <li><a href="/download/">Downloads</a></li>
              </ul>
            </div>
            <div id="dn-cold" class="column">
              <h3><a href="/distribute/">Distribute</a></h3>
              <ul>
                <li><a href="/programs/">Developer Program</a></li>
                <li><a href="/app-store/">App Store</a></li>
                <li><a href="/app-store/review/">App Review</a></li>
                <li><a href="/macos/distribution/">Mac Software</a></li>
                <li><a href="/business/distribute/">Apps for Business</a></li>
                <li><a href="/safari/extensions/">Safari Extensions</a></li>
                <li><a href="/app-store/marketing/guidelines/">Marketing Resources</a></li>
                <li><a href="/softwarelicensing/">Trademark Licensing</a></li>
              </ul>
            </div>
            <div id="dn-cole" class="column">
              <h3><a href="/support/">Support</a></h3>
              <ul>
                <li><a href="https://forums.developer.apple.com">Developer Forums</a></li>
                <li><a href="/bug-reporting/">Bug Reporting</a></li>
                <li><a href="/terms/">License Agreements</a></li>
                <li><a href="/system-status/">System Status</a></li>
                <li><a href="/contact/">Contact Us</a></li>
              </ul>
              <h3><a href="/account/">Account</a></h3>
              <ul>
                <li><a href="/account/ios/certificate/">Certificates, IDs &amp; Profiles</a></li>
                <li><a href="https://appstoreconnect.apple.com/">App Store Connect</a></li>
              </ul>
            </div>
          </div>
        </nav>
        <div class="ac-gf-footer-legal">
          <div class="ac-gf-footer-news"> To receive the latest developer news, visit and subscribe to our <a href="/news/">News and Updates</a>.
          </div>
          <div class="ac-gf-footer-legal-copyright">Copyright © 2020 Apple Inc. All rights reserved.</div>
          <div class="ac-gf-footer-legal-links">
            <a href="https://www.apple.com/legal/internet-services/terms/site.html" class="first">Terms of Use</a>
            <a href="https://www.apple.com/privacy/privacy-policy/">Privacy Policy</a>
            <a href="/bug-reporting/">Report Bugs</a>
            <a href="/contact/submit/?subject=website-feedback">Feedback</a>
          </div>
          <div class="ac-gf-footer-language-links">
            <a href="/cn/" class="first">简体中文</a>
            <a href="/jp/">日本語</a>
            <a href="/kr/">한국어</a>
          </div>
        </div>
      </footer></section></div></div><script id="bootstrap-data" type="application/json">{"id":3362153,"abstract":"<div><p>Develop apps in SwiftUI with an interactive preview that keeps the code and layout in sync.<\/p><\/div>","discussion":"<div><p>If you choose the SwiftUI framework to develop your app, you can see an interactive preview as you lay out your user interface. Xcode keeps the changes you make to the source code, the user interface layout, and the inspector in sync. For example, when you edit attributes in the inspector, Xcode adds the corresponding code to the source file.<\/p><\/div><h3 id=\"3362152\">Display the SwiftUI Preview<\/h3><div><p>To show the preview, select a file that uses SwiftUI in the project navigator, and choose Editor &gt; Canvas. Then click the Resume button in the upper-right corner of the canvas to start the preview. Xcode builds and runs the code, displaying the results directly in the canvas.<\/p><figure id=\"3381037\"><img class=\"centered-block\" src=\"https:\/\/docs-assets.developer.apple.com\/published\/8146913601\/7a6b441e-d9b0-400a-b3f0-027413778674.png\" srcSet=\"https:\/\/docs-assets.developer.apple.com\/published\/8146913601\/7a6b441e-d9b0-400a-b3f0-027413778674.png 2x\" alt=\"Screenshot showing a SwiftUI file selected in the project navigator and preview displayed in the editor area.\" width=\"720\" height=\"auto\"\/><\/figure><p>Use the controls at the bottom of the preview to run the app on a simulated device in the canvas, with or without a debug session, or run the app on a connected device.<\/p><\/div><h3 id=\"3362154\">Add Views and Modifiers<\/h3><div><p>To add views and modifiers to your app, click the Library button (+) in the toolbar to open the library, then drag user interface elements from the library to either the canvas or source code. Regardless of where you drop the elements, Xcode keeps the source code and the layout in sync.<\/p><figure id=\"3362210\"><img class=\"centered-block\" src=\"https:\/\/docs-assets.developer.apple.com\/published\/e74cff0c09\/a07fe257-ab33-42ea-b1ae-4c9a909984aa.png\" srcSet=\"https:\/\/docs-assets.developer.apple.com\/published\/e74cff0c09\/a07fe257-ab33-42ea-b1ae-4c9a909984aa.png 2x\" alt=\"Screenshot showing the library when a SwiftUI element is selected.\" width=\"142\" height=\"auto\"\/><\/figure><p><\/p><\/div><h3 id=\"3362155\">Edit User Interface Elements<\/h3><div><p>Edit element attributes using either the Action menu or the inspector, or by entering code in the source editor. Command-click the element in the canvas or the structure in the code, choose Show SwiftUI Inspector from the Action menu, then change the attributes in the next pane. Alternatively, choose View &gt; Inspectors &gt; Show Attributes Inspector, and change the attributes in the Attributes inspector that appears on the right.<\/p><figure id=\"3384914\"><img class=\"centered-block\" src=\"https:\/\/docs-assets.developer.apple.com\/published\/7a60b72cde\/57c6dfb5-f977-43d2-abeb-01efcfd655b7.png\" srcSet=\"https:\/\/docs-assets.developer.apple.com\/published\/7a60b72cde\/57c6dfb5-f977-43d2-abeb-01efcfd655b7.png 2x\" alt=\"Screenshot showing the Action menu in the canvas with the Show Attributes Inspector menu item selected.\" width=\"612\" height=\"auto\"\/><\/figure><p><\/p><\/div><h3 id=\"3362156\">Embed User Interface Elements<\/h3><div><p>Additionally, you can modify the user interface by embedding elements in other structures. Command-click an element in the source code or in the canvas, then choose an &quot;Embed in [Generic Structure]&quot; action from the pop-up menu. For example, choose &quot;Embed in HStack&quot; to embed an element that arranges a view&#x27;s children in a horizontal line.<\/p><figure id=\"3384913\"><img class=\"centered-block\" src=\"https:\/\/docs-assets.developer.apple.com\/published\/4f4304fa18\/d659a2a4-b500-4e99-a005-f0ff62887239.png\" srcSet=\"https:\/\/docs-assets.developer.apple.com\/published\/4f4304fa18\/d659a2a4-b500-4e99-a005-f0ff62887239.png 2x\" alt=\"Screenshot showing the Action menu in the source editor with the Embed in HStack menu item selected.\" width=\"612\" height=\"auto\"\/><\/figure><p>To learn more about SwiftUI, go to <a href=\"\/tutorials\/swiftui\/tutorials\">Learn to Make Apps with SwiftUI<\/a>.<\/p><\/div>","title":{"content":"Creating Your App's Interface with SwiftUI"},"containingGroup":[{"id":3193088,"role":"task","paths":[],"symbols":[{"id":3362153,"role":"article","paths":["documentation\/xcode\/creating_your_app_s_interface_with_swiftui"],"abstract":"<div><p>Develop apps in SwiftUI with an interactive preview that keeps the code and layout in sync.<\/p><\/div>","title":{"content":"Creating Your App's Interface with SwiftUI"}},{"id":2993824,"role":"article","paths":["documentation\/xcode\/supporting_dark_mode_in_your_interface","documentation\/uikit\/appearance_customization\/supporting_dark_mode_in_your_interface","documentation\/appkit\/appearance_customization\/supporting_dark_mode_in_your_interface"],"hasChildren":true,"abstract":"<div><p>Update colors, images, and behaviors so that your app adapts automatically when Dark Mode is active.<\/p><\/div>","title":{"content":"Supporting Dark Mode in Your Interface"}},{"id":3374583,"role":"article","paths":["documentation\/xcode\/creating_custom_symbol_images_for_your_app","documentation\/uikit\/uiimage\/creating_custom_symbol_images_for_your_app"],"abstract":"<div><p>Create symbol images and expand on the icons provided by SF Symbols.<\/p><\/div>","title":{"content":"Creating Custom Symbol Images for Your App"}}],"title":{"content":"Interface"}}],"role":"article","language":"swift","roleHeading":"Article","languages":["occ","swift"],"variants":{"occ":{"paths":["documentation\/xcode\/creating_your_app_s_interface_with_swiftui"]},"swift":{"paths":["documentation\/xcode\/creating_your_app_s_interface_with_swiftui"]}},"pid":492525,"paths":["documentation\/xcode\/creating_your_app_s_interface_with_swiftui"],"hierarchy":[[{"id":3151777,"role":"collection","title":{"content":"Xcode"},"paths":["documentation\/xcode"]}]],"legalNotices":{"copyright":"Copyright &copy; 2020 Apple Inc. All rights reserved.","termsOfUse":"https:\/\/www.apple.com\/legal\/internet-services\/terms\/site.html","privacyPolicy":"https:\/\/www.apple.com\/privacy\/privacy-policy"}}</script><script src="/documentation/__assets/TopicDetail-e635bc11.js"></script><script src="/documentation/__assets/analytics-8acae80a.js"></script></body></html>